package se.softstuff.nb.nb.translate.ide;

import java.util.HashMap;
import java.util.Map;
import javax.swing.JPanel;
import org.netbeans.api.project.Project;
import org.netbeans.api.project.ProjectInformation;
import org.netbeans.api.project.ProjectUtils;
import org.netbeans.api.project.ui.OpenProjects;
import org.openide.util.NbBundle;
import se.softstuff.nb.domain.NbBundleDiff;
import se.softstuff.nb.domain.ProjectBundleInfo;
import se.softstuff.nb.domain.swing.ColumnRenderer;
import se.softstuff.nb.domain.swing.DynamicTableModel;

public final class ImportVisualPanel2 extends JPanel {
    
    private DynamicTableModel tableModel;
    private Map<String,Project> openProjects;
            
    public ImportVisualPanel2() {
        tableModel = new DynamicTableModel();
        initComponents();  
        tableModel.addColumn(new ModuleNameRenderer(), new VesionRenderer(), new ModuleRefRenderer(), new MappedRenderer());
    }

    @Override
    public String getName() {
        return NbBundle.getMessage(ImportVisualPanel2.class, "ImportVisualPanel2.bulletin");
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        changedModulelPanel = new javax.swing.JScrollPane();
        moduleTable = new javax.swing.JTable();

        setName("Form"); // NOI18N

        changedModulelPanel.setName("changedModulelPanel"); // NOI18N

        moduleTable.setModel(tableModel);
        moduleTable.setName("moduleTable"); // NOI18N
        changedModulelPanel.setViewportView(moduleTable);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(changedModulelPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 425, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(changedModulelPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 278, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane changedModulelPanel;
    private javax.swing.JTable moduleTable;
    // End of variables declaration//GEN-END:variables

    
    void setTranslation(NbBundleDiff translation) {        
        openProjects = new HashMap<String, Project>();
                
        for(Project open : OpenProjects.getDefault().getOpenProjects()){
            ProjectInformation info = ProjectUtils.getInformation(open);
            openProjects.put(info.getName(), open);
        }
        
         tableModel.setRows(translation.getChangedProjects());                
    }

    Map<String,Project> getSourceProjects() {
        return openProjects;
    }

    
    private class ModuleNameRenderer extends ColumnRenderer<ProjectBundleInfo, String> {

        @Override
        public String render(ProjectBundleInfo row) {
            return row.getDisplayName();
        }

        @Override
        public String headerText() {
            return NbBundle.getMessage(ImportVisualPanel2.class, "ModuleNameRenderer.header.text");
        }

        @Override
        public String headerTooltip() {
            return NbBundle.getMessage(ImportVisualPanel2.class, "ModuleNameRenderer.header.tooltip");
        }
        
    }
    
    private class ModuleRefRenderer extends ColumnRenderer<ProjectBundleInfo, String> {

        @Override
        public String render(ProjectBundleInfo row) {
            return row.getModuleRef();
        }

        @Override
        public String headerText() {
            return NbBundle.getMessage(ImportVisualPanel2.class, "ModuleRefRenderer.header.text");
        }

        @Override
        public String headerTooltip() {
            return NbBundle.getMessage(ImportVisualPanel2.class, "ModuleRefRenderer.header.tooltip");
        }
        
    }
    
    private class VesionRenderer extends ColumnRenderer<ProjectBundleInfo, String> {

        @Override
        public String render(ProjectBundleInfo row) {
            return row.getVersion();
        }

        @Override
        public String headerText() {
            return NbBundle.getMessage(ImportVisualPanel2.class, "VesionRenderer.header.text");
        }

        @Override
        public String headerTooltip() {
            return NbBundle.getMessage(ImportVisualPanel2.class, "VesionRenderer.header.tooltip");
        }
        
    }
    
    private class MappedRenderer extends ColumnRenderer<ProjectBundleInfo, Boolean> {

        @Override
        public Boolean render(ProjectBundleInfo row) {
            return openProjects.containsKey(row.getName());
        }

        @Override
        public String headerText() {
            return NbBundle.getMessage(ImportVisualPanel2.class, "MappedRenderer.header.text");
        }

        @Override
        public String headerTooltip() {
            return NbBundle.getMessage(ImportVisualPanel2.class, "MappedRenderer.header.tooltip");
        }
        
    }
}
